"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = getDevice;

var _drylusStyleVars = _interopRequireDefault(require("@drawbotics/drylus-style-vars"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _parseMaxWidth(mediaQuery) {
  var _mediaQuery$match = mediaQuery.match(/max-width: (\d+)/),
      _mediaQuery$match2 = _slicedToArray(_mediaQuery$match, 2),
      maxWidth = _mediaQuery$match2[1];

  return parseInt(maxWidth);
}

function _isPhonePortrait() {
  return window.innerWidth <= _parseMaxWidth(_drylusStyleVars["default"].phoneXl);
}

function _isPhoneLandscape() {
  return window.innerWidth <= _parseMaxWidth(_drylusStyleVars["default"].phoneXlLandscape) && !_isPhonePortrait() && window.innerHeight <= 500;
}

function _isPhone() {
  return _isPhoneLandscape() || _isPhonePortrait();
}

function _isDesktop() {
  return !_isPhone();
}

function getDevice() {
  return {
    isPhone: _isPhone(),
    isPhoneLandscape: _isPhoneLandscape(),
    isPhonePortrait: _isPhonePortrait(),
    isDesktop: _isDesktop()
  };
}