import sv from '@drawbotics/drylus-style-vars';


function _parseMaxWidth(mediaQuery) {
  const [ , maxWidth ] = mediaQuery.match(/max-width: (\d+)/);
  return parseInt(maxWidth);
}


function _isPhonePortrait() {
  return window.innerWidth <= _parseMaxWidth(sv.phoneXl);
}


function _isPhoneLandscape() {
  return window.innerWidth <= _parseMaxWidth(sv.phoneXlLandscape)
    && ! _isPhonePortrait()
    && window.innerHeight <= 500;
}


function _isPhone() {
  return _isPhoneLandscape() || _isPhonePortrait();
}


function _isDesktop() {
  return ! _isPhone();
}


export default function getDevice() {
  return {
    isPhone: _isPhone(),
    isPhoneLandscape: _isPhoneLandscape(),
    isPhonePortrait: _isPhonePortrait(),
    isDesktop: _isDesktop(),
  };
}
