import { useState, useEffect } from 'react';

import getDevice from './get-device';


export default function useIsDevice() {
  const [ device, setDevice ] = useState(getDevice());

  useEffect(() => {
    const handleResize = () => {
      setDevice(getDevice());
    };

    window.addEventListener('resize', handleResize);
    return () => {
      window.removeEventListener('resize', handleResize);
    };
  }, []);

  return device;
}
